import 'dart:io';

import 'package:path/path.dart' as path;

List<Future> create_start_files(String dir, String jar, {int min_ram = 512, int max_ram = 2048, bool gui=false}) {

  // java arguments
  List<String> args = [];
  if(min_ram != null) args.add("-Xms${min_ram}M");
  if(max_ram != null) args.add("-Xmx${max_ram}M");

  args.addAll(["-jar", jar]);

  // Programm arguments
  if(!gui) args.add("nogui");
  
  return [
    File("$dir/start.bat").writeAsString('''@echo off
:: Server start file, automatically generated by dart-mc-launcher
:: This just contains a simple start command to start the server
java ''' +args.join(" ")),
    File("$dir/start.sh").writeAsString('''# Server start file, automatically generated by dart-mc-launcher
# This just contains a simple start command to start the server
java ''' +args.join(" "))
  ];
}

Future createEula(String p, bool accepted){
  return File(path.join(p,"eula.txt")).writeAsString("eula=$accepted");
}